//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern double Period1 =  32;
extern double Period2 =   5;
extern double Period3 =   5;
extern int    Price   = PRICE_CLOSE;

double tsi[];
double tsil[];
double tsihuu[];
double tsihdd[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,tsihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tsihdd); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tsil);
   SetIndexBuffer(3,tsi);
   SetIndexBuffer(4,slope);
      IndicatorShortName("Blau ergodic true strength index trade ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
         double avg = iEma(iEma(iEma(        priceDiff ,Period1,i,0),Period2,i,1),Period3,i,2);
         double ava = iEma(iEma(iEma(MathAbs(priceDiff),Period1,i,3),Period2,i,4),Period3,i,5);
            if (ava != 0)
                  tsi[i] = 100.0*avg/ava;
            else  tsi[i] = 0;                  
            tsihuu[i] = EMPTY_VALUE;
            tsihdd[i] = EMPTY_VALUE;
            tsil[i]   = 0;

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
               if (tsi[i] > tsi[i+1]) slope[i] =  1;
               if (tsi[i] < tsi[i+1]) slope[i] = -1;
               if (tsi[i]>0 && slope[i]== 1) { tsihuu[i] = tsi[i]; tsil[i] = tsi[i]; }
               if (tsi[i]<0 && slope[i]==-1) { tsihdd[i] = tsi[i]; tsil[i] = tsi[i]; }
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][6];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}